/* img_cache.c generated by valac 0.11.5, the Vala compiler
 * generated from img_cache.vala, do not modify */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <libsoup/soup.h>


#define TYPE_IMG_CACHE (img_cache_get_type ())
#define IMG_CACHE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMG_CACHE, ImgCache))
#define IMG_CACHE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IMG_CACHE, ImgCacheClass))
#define IS_IMG_CACHE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMG_CACHE))
#define IS_IMG_CACHE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IMG_CACHE))
#define IMG_CACHE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IMG_CACHE, ImgCacheClass))

typedef struct _ImgCache ImgCache;
typedef struct _ImgCacheClass ImgCacheClass;
typedef struct _ImgCachePrivate ImgCachePrivate;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _ImgCache {
	GObject parent_instance;
	ImgCachePrivate * priv;
};

struct _ImgCacheClass {
	GObjectClass parent_class;
};

struct _ImgCachePrivate {
	GRegex* url_re;
	gchar* cache_path;
};


static gpointer img_cache_parent_class = NULL;

GType img_cache_get_type (void) G_GNUC_CONST;
#define IMG_CACHE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_IMG_CACHE, ImgCachePrivate))
enum  {
	IMG_CACHE_DUMMY_PROPERTY
};
gboolean img_cache_exist (ImgCache* self, const gchar* url);
static gchar* img_cache_url_to_name (ImgCache* self, const gchar* url);
gchar* img_cache_download (ImgCache* self, const gchar* url);
static gchar* img_cache_encode_url (ImgCache* self, const gchar* url, GError** error);
ImgCache* img_cache_new (void);
ImgCache* img_cache_construct (GType object_type);
static GObject * img_cache_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void img_cache_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


gboolean img_cache_exist (ImgCache* self, const gchar* url) {
	gboolean result = FALSE;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* new_path;
	GFile* _tmp3_ = NULL;
	GFile* f;
	gboolean _tmp4_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (url != NULL, FALSE);
	_tmp0_ = img_cache_url_to_name (self, url);
	_tmp1_ = _tmp0_;
	new_path = (_tmp2_ = g_strconcat (self->priv->cache_path, _tmp1_, NULL), _g_free0 (_tmp1_), _tmp2_);
	_tmp3_ = g_file_new_for_path (new_path);
	f = _tmp3_;
	_tmp4_ = g_file_query_exists (f, NULL);
	if (!_tmp4_) {
		result = FALSE;
		_g_object_unref0 (f);
		_g_free0 (new_path);
		return result;
	} else {
		result = TRUE;
		_g_object_unref0 (f);
		_g_free0 (new_path);
		return result;
	}
	_g_object_unref0 (f);
	_g_free0 (new_path);
}


gchar* img_cache_download (ImgCache* self, const gchar* url) {
	gchar* result = NULL;
	gboolean _tmp0_;
	SoupSessionSync* _tmp4_ = NULL;
	SoupSession* session;
	SoupMessage* msg = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_;
	gchar* _tmp7_;
	SoupMessage* _tmp8_ = NULL;
	SoupMessage* _tmp9_;
	gint status_code;
	guint _tmp10_;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* new_path;
	gboolean _tmp14_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (url != NULL, NULL);
	_tmp0_ = img_cache_exist (self, url);
	if (_tmp0_) {
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp1_ = img_cache_url_to_name (self, url);
		_tmp2_ = _tmp1_;
		result = (_tmp3_ = g_strconcat (self->priv->cache_path, _tmp2_, NULL), _g_free0 (_tmp2_), _tmp3_);
		return result;
	}
	_tmp4_ = (SoupSessionSync*) soup_session_sync_new ();
	session = (SoupSession*) _tmp4_;
	_tmp5_ = img_cache_encode_url (self, url, &_inner_error_);
	_tmp6_ = _tmp5_;
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_REGEX_ERROR) {
			goto __catch1_g_regex_error;
		}
		_g_object_unref0 (msg);
		_g_object_unref0 (session);
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp7_ = _tmp6_;
	_tmp8_ = soup_message_new ("GET", _tmp7_);
	_tmp9_ = _tmp8_;
	_g_object_unref0 (msg);
	msg = _tmp9_;
	_g_free0 (_tmp7_);
	goto __finally1;
	__catch1_g_regex_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_debug ("img_cache.vala:48: %s", e->message);
		result = NULL;
		_g_error_free0 (e);
		_g_object_unref0 (msg);
		_g_object_unref0 (session);
		return result;
	}
	__finally1:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (msg);
		_g_object_unref0 (session);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	status_code = 0;
	_tmp10_ = soup_session_send_message (session, msg);
	status_code = (gint) _tmp10_;
	if (status_code != 200) {
		g_debug ("img_cache.vala:57: status code is %d", status_code);
		result = NULL;
		_g_object_unref0 (msg);
		_g_object_unref0 (session);
		return result;
	}
	_tmp11_ = img_cache_url_to_name (self, url);
	_tmp12_ = _tmp11_;
	new_path = (_tmp13_ = g_strconcat (self->priv->cache_path, _tmp12_, NULL), _g_free0 (_tmp12_), _tmp13_);
	_tmp14_ = save_soup_data (msg->response_body, new_path);
	if (!_tmp14_) {
		result = NULL;
		_g_free0 (new_path);
		_g_object_unref0 (msg);
		_g_object_unref0 (session);
		return result;
	}
	result = new_path;
	_g_object_unref0 (msg);
	_g_object_unref0 (session);
	return result;
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	GRegex* _tmp2_ = NULL;
	GRegex* _tmp3_;
	GRegex* regex;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	_tmp0_ = g_regex_escape_string (old, -1);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_regex_new (_tmp1_, 0, 0, &_inner_error_);
	regex = (_tmp3_ = _tmp2_, _g_free0 (_tmp1_), _tmp3_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_REGEX_ERROR) {
			goto __catch2_g_regex_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp4_ = g_regex_replace_literal (regex, self, (gssize) (-1), 0, replacement, 0, &_inner_error_);
	_tmp5_ = _tmp4_;
	if (_inner_error_ != NULL) {
		_g_regex_unref0 (regex);
		if (_inner_error_->domain == G_REGEX_ERROR) {
			goto __catch2_g_regex_error;
		}
		_g_regex_unref0 (regex);
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = _tmp5_;
	_g_regex_unref0 (regex);
	return result;
	_g_regex_unref0 (regex);
	goto __finally2;
	__catch2_g_regex_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally2:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static gchar* img_cache_url_to_name (ImgCache* self, const gchar* url) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* save_name;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (url != NULL, NULL);
	_tmp0_ = string_replace (url, "/", "");
	save_name = _tmp0_;
	result = save_name;
	return result;
}


static gchar* img_cache_encode_url (ImgCache* self, const gchar* url, GError** error) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* old_url_path;
	const gchar* _tmp1_ = NULL;
	gchar** _tmp2_;
	gchar** _tmp3_ = NULL;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* new_url_path;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (url != NULL, NULL);
	_tmp0_ = g_regex_replace (self->priv->url_re, url, (gssize) (-1), 0, "\\3", 0, &_inner_error_);
	old_url_path = _tmp0_;
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_REGEX_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp1_ = soup_form_encode ("", old_url_path, NULL);
	_tmp3_ = _tmp2_ = g_strsplit (_tmp1_, "=", 0);
	_tmp4_ = _tmp3_;
	_tmp4__length1 = _vala_array_length (_tmp2_);
	_tmp5_ = g_strdup (_tmp4_[1]);
	new_url_path = (_tmp6_ = _tmp5_, _tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL), _tmp6_);
	_tmp7_ = string_replace (url, old_url_path, new_url_path);
	_tmp8_ = _tmp7_;
	_g_free0 (new_url_path);
	new_url_path = _tmp8_;
	_tmp9_ = string_replace (new_url_path, "%2F", "/");
	_tmp10_ = _tmp9_;
	_g_free0 (new_url_path);
	new_url_path = _tmp10_;
	result = new_url_path;
	_g_free0 (old_url_path);
	return result;
}


ImgCache* img_cache_construct (GType object_type) {
	ImgCache * self = NULL;
	self = (ImgCache*) g_object_new (object_type, NULL);
	return self;
}


ImgCache* img_cache_new (void) {
	return img_cache_construct (TYPE_IMG_CACHE);
}


static GObject * img_cache_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	ImgCache * self;
	GRegex* _tmp0_ = NULL;
	GRegex* _tmp1_;
	GRegex* _tmp2_;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GFile* _tmp7_ = NULL;
	GFile* cache_dir;
	gboolean _tmp8_;
	GError * _inner_error_ = NULL;
	parent_class = G_OBJECT_CLASS (img_cache_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = IMG_CACHE (obj);
	_tmp0_ = g_regex_new ("(http://)([a-zA-Z0-9-\\.]+)/(.*)", 0, 0, &_inner_error_);
	_tmp1_ = _tmp0_;
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_REGEX_ERROR) {
			goto __catch3_g_regex_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	_tmp2_ = _tmp1_;
	_g_regex_unref0 (self->priv->url_re);
	self->priv->url_re = _tmp2_;
	goto __finally3;
	__catch3_g_regex_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_debug ("img_cache.vala:12: %s", e->message);
		_g_error_free0 (e);
	}
	__finally3:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	_tmp3_ = g_get_user_cache_dir ();
	_tmp4_ = g_strdup_printf ("/%s", "pino/");
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strconcat (_tmp3_, _tmp5_, NULL);
	_g_free0 (self->priv->cache_path);
	self->priv->cache_path = _tmp6_;
	_g_free0 (_tmp5_);
	_tmp7_ = g_file_new_for_path (self->priv->cache_path);
	cache_dir = _tmp7_;
	_tmp8_ = g_file_query_exists (cache_dir, NULL);
	if (!_tmp8_) {
		g_file_make_directory (cache_dir, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch4_g_error;
		}
		goto __finally4;
		__catch4_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			g_debug ("img_cache.vala:23: %s", e->message);
			_g_error_free0 (e);
		}
		__finally4:
		if (_inner_error_ != NULL) {
			_g_object_unref0 (cache_dir);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
		}
	}
	_g_object_unref0 (cache_dir);
	return obj;
}


static void img_cache_class_init (ImgCacheClass * klass) {
	img_cache_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ImgCachePrivate));
	G_OBJECT_CLASS (klass)->constructor = img_cache_constructor;
	G_OBJECT_CLASS (klass)->finalize = img_cache_finalize;
}


static void img_cache_instance_init (ImgCache * self) {
	self->priv = IMG_CACHE_GET_PRIVATE (self);
}


static void img_cache_finalize (GObject* obj) {
	ImgCache * self;
	self = IMG_CACHE (obj);
	_g_regex_unref0 (self->priv->url_re);
	_g_free0 (self->priv->cache_path);
	G_OBJECT_CLASS (img_cache_parent_class)->finalize (obj);
}


GType img_cache_get_type (void) {
	static volatile gsize img_cache_type_id__volatile = 0;
	if (g_once_init_enter (&img_cache_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ImgCacheClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) img_cache_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ImgCache), 0, (GInstanceInitFunc) img_cache_instance_init, NULL };
		GType img_cache_type_id;
		img_cache_type_id = g_type_register_static (G_TYPE_OBJECT, "ImgCache", &g_define_type_info, 0);
		g_once_init_leave (&img_cache_type_id__volatile, img_cache_type_id);
	}
	return img_cache_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



