/* time_utils.c generated by valac 0.11.5, the Vala compiler
 * generated from time_utils.vala, do not modify */

/* time_utils.vala
 *
 * Copyright (C) 2009-2010  troorl
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	troorl <troorl@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))



void time_utils_get_current_time (struct tm* result);
gint time_utils_tz_delta (struct tm* t);
void time_utils_str_to_time (const gchar* str, struct tm* result);


static void g_time_local (time_t time, struct tm* result) {
	struct tm _result_ = {0};
	struct tm _tmp0_ = {0};
	localtime_r (&time, &_tmp0_);
	_result_ = _tmp0_;
	*result = _result_;
	return;
}


void time_utils_get_current_time (struct tm* result) {
	GTimeVal tval = {0};
	struct tm _tmp0_ = {0};
	struct tm _tmp1_ = {0};
	g_get_current_time (&tval);
	g_get_current_time (&tval);
	_tmp1_ = (g_time_local ((time_t) tval.tv_sec, &_tmp0_), _tmp0_);
	*result = _tmp1_;
	return;
}


static gchar* g_time_format (struct tm *self, const gchar* format) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* buffer;
	gint buffer_length1;
	gint _buffer_size_;
	gchar* _tmp1_;
	g_return_val_if_fail (format != NULL, NULL);
	_tmp0_ = g_new0 (gchar, 64);
	buffer = _tmp0_;
	buffer_length1 = 64;
	_buffer_size_ = 64;
	strftime (buffer, buffer_length1, format, &(*self));
	_tmp1_ = g_strdup ((const gchar*) buffer);
	result = _tmp1_;
	buffer = (g_free (buffer), NULL);
	return result;
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	gint _tmp0_;
	glong string_length;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	string_length = (glong) _tmp0_;
	if (offset < 0) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= 0, NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < 0) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp1_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp1_;
	return result;
}


static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	result = ((gchar*) self)[index];
	return result;
}


gint time_utils_tz_delta (struct tm* t) {
	gint result = 0;
	gint xdelta;
	gchar* _tmp0_ = NULL;
	gchar* sdelta;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gint _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	gint _tmp6_;
	gchar _tmp7_;
	xdelta = 0;
	_tmp0_ = g_time_format (t, "%z");
	sdelta = _tmp0_;
	_tmp1_ = string_substring (sdelta, (glong) 1, (glong) 2);
	_tmp2_ = _tmp1_;
	_tmp3_ = atoi (_tmp2_);
	xdelta = xdelta + (_tmp3_ * 3600);
	_g_free0 (_tmp2_);
	_tmp4_ = string_substring (sdelta, (glong) 3, (glong) 2);
	_tmp5_ = _tmp4_;
	_tmp6_ = atoi (_tmp5_);
	xdelta = xdelta + (_tmp6_ * 60);
	_g_free0 (_tmp5_);
	_tmp7_ = string_get (sdelta, (glong) 0);
	if (_tmp7_ == '-') {
		xdelta = xdelta * (-1);
	}
	result = xdelta;
	_g_free0 (sdelta);
	return result;
}


void time_utils_str_to_time (const gchar* str, struct tm* result) {
	struct tm tmpTime = {0};
	time_t _tmp0_;
	time_t tt;
	struct tm _tmp1_ = {0};
	struct tm _tmp2_ = {0};
	struct tm tmp;
	gint _tmp3_;
	gint delta;
	gint int_t;
	struct tm _tmp4_ = {0};
	struct tm _tmp5_ = {0};
	g_return_if_fail (str != NULL);
	memset (&tmpTime, 0, sizeof (struct tm));
	strptime (str, "%a %b %d %T +0000 %Y", &tmpTime);
	_tmp0_ = mktime (&tmpTime);
	tt = _tmp0_;
	_tmp2_ = (g_time_local (tt, &_tmp1_), _tmp1_);
	tmp = _tmp2_;
	_tmp3_ = time_utils_tz_delta (&tmp);
	delta = _tmp3_;
	int_t = ((gint) tt) + delta;
	_tmp5_ = (g_time_local ((time_t) int_t, &_tmp4_), _tmp4_);
	*result = _tmp5_;
	return;
}



